AcWing 4247. 糖果(差分约束最短路)
Posted MangataTS
tags:
篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了AcWing 4247. 糖果(差分约束最短路)相关的知识,希望对你有一定的参考价值。
题目连接
https://www.acwing.com/problem/content/4250/
http://poj.org/problem?id=3159
思路
假设第i个同学得到的糖果数量为 a [ i ] a[i] a[i],然后第j个同学得到的糖果数位 a [ j ] a[j] a[j]现在要求第j个同学的糖果数不超过 a [ i ] + k a[i] + k a[i]+k个,也就是 a [ j ] − a [ i ] < = k a[j] - a[i] <= k a[j]−a[i]<=k,那么我们要求的就是 a [ n ] − a [ 1 ] a[n]-a[1] a[n]−a[1]的最大值
我们将上述不等式变形: a [ j ] < = a [ i ] + k a[j] <= a[i] + k a[j]<=a[i]+k,我们发现这个等式不就是最短路的松弛条件吗,所以我们直接将 a a a、 b b b连成一条有向边,边权为 c c c,然后跑一个起点为1的最短路即可,最后输出 d i s [ n ] dis[n] dis[n]的值,这个题也是一个经典的差分约束题目,关于差分约束简单提一下,感兴趣可以去百度一下,差分约束就是给出一些形如x-y<=b不等式的约束,问你是否满足有解的问题
代码
链式前向星优化
#include<iostream>
#include<cstring>
#include<algorithm>
#include<cstdio>
#include<queue>
using namespace std;
#define PII pair<int,int>
#define INF 0x3f3f3f3f
const int N = 150000 + 10;
struct Node
int v,w,next;
E[N];
int head[N],dis[N],cnt,n,m,vis[N];
void add(int u,int v,int w)
E[cnt].v = v;
E[cnt].w = w;
E[cnt].next = head[u];
head[u] = cnt++;
void DJ(int s)
priority_queue<PII,vector<PII>,greater<PII> > que;
que.push(0,s);
dis[s] = 0;
while(!que.empty())
int t = que.top().second;
int w = que.top().first;
que.pop();
if(dis[t] < w) continue;
for(int i = head[t];~i;i=E[i].next)
int j = E[i].v;
if(dis[j] > dis[t] + E[i].w)
dis[j] = dis[t] + E[i].w;
que.push(dis[j],j);
int main()
scanf("%d%d",&n,&m);
memset(dis,0x3f,sizeof dis);
memset(head,-1,sizeof head);
int u,v,w;
for(int i = 1;i <= m; ++i)
scanf("%d%d%d",&u,&v,&w);
add(u,v,w);
DJ(1);
printf("%d\\n",dis[n]);
return 0;
vector容器存储
#include<bits/stdc++.h>
using namespace std;
//----------------自定义部分----------------
#define ll long long
#define mod 1000000007
#define endl "\\n"
#define PII pair<int,int>
#define INF 0x3f3f3f3f
int dx[4]=0,-1,0,1,dy[4]=-1,0,1,0;
ll ksm(ll a,ll b)
ll ans = 1;
for(;b;b>>=1LL)
if(b & 1) ans = ans * a % mod;
a = a * a % mod;
return ans;
ll lowbit(ll x)return -x & x;
const int N = 2e6+10;
//----------------自定义部分----------------
int n,m,q;
vector<PII> E[N];
int dis[N];
bool vis[N];
void slove()
memset(dis,INF,sizeof dis);
dis[1] = 0;
priority_queue<PII,vector<PII>,greater<PII> >que;
que.push(0,1);
while(!que.empty())
PII t = que.top();
que.pop();
int p = t.second;
if(vis[p]) continue;
vis[p] = true;
for(int i = 0,l = E[p].size(); i < l; ++i)
int j = E[p][i].first,k = E[p][i].second;
if(dis[j] > dis[p] + k)
dis[j] = dis[p] + k;
que.push(dis[j],j);
if(dis[n] == INF)
cout<<-1<<endl;
else cout<<dis[n]<<endl;
int main()
std::ios::sync_with_stdio(false);
std::cin.tie(nullptr);
std::cout.tie(nullptr);
cin>>n>>m;
int u,v,w;
for(int i = 0;i < m; ++i)
cin>>u>>v>>w;
E[u].push_back(v,w);
slove();
return 0;
以上是关于AcWing 4247. 糖果(差分约束最短路)的主要内容,如果未能解决你的问题,请参考以下文章